'''
Created on Feb 18, 2018

@author: ola
'''
def hailstone(start,printing=False):
    """
    start is int value for hailstone/collatz
    return int: number of steps in sequence
    with 1 as last value of sequence, e.g.,
    starting at 1 is zero steps
    printing is boolean, if true print all values
    """
    
    steps = 0
    current = start
    while current != 1:
        if printing:
            print("%d\t%d" % (steps,current))
        if current % 2 == 0:
            current /= 2
        else:
            current = current * 3 + 1
        steps += 1
    
    if printing:
        print("%d\t%d" % (steps,current))
    return steps
        
def analyze(limit):
    counts = []
    # max index into count is limit, but start at 1
    for _ in range(limit+1):
        counts.append(0)
    
    for n in range(1,limit+1):
        counts[n] = hailstone(n)
        
    avg = sum(counts)/len(counts)
    mx = max(counts)
    dex = counts.index(mx)
    print("average",avg)
    print("max is %d at %d" % (mx,dex))

if __name__ == '__main__':
     num = 3711
     s = hailstone(num,True)
     print(num,s)
     analyze(5000)