'''
Created on Feb 19, 2018

@author: ola
'''
import Collatz,math
import matplotlib.pyplot as plt

def groupplot(intvals,stepvals,groupsize):
    mn = min(stepvals)
    mx = max(stepvals)

    intervals = (mx-mn)//groupsize
    chunks = []
    for _ in range(groupsize+1):
        chunks.append([])
    xvals = []
    for low in range(groupsize+1):
        xvals.append(mn+low*intervals)
    for dex in range(len(intvals)):
        num = intvals[dex]
        steps = stepvals[dex]
        bucket = (steps-mn)//intervals
        print("%d, %d, %d" % (num,steps,bucket))
        chunks[bucket].append(num)
    
    yvals = []
    for val in chunks:
        yvals.append(len(val))
    for dex in range(len(xvals)):
        print("%d\t%d" % (xvals[dex],yvals[dex]))
    scaled = []
    for val in yvals:
        scaled.append(val*4)    
    print("min = %d, max = %d with %d for %d" % (mn,mx,intervals,groupsize))
    
    #plt.subplot(2,1,2)
    plt.scatter(xvals,yvals,s=scaled)
    plt.ylabel("# numbers with steps in range")
    plt.xlabel("length of collatz sequence")
    plt.margins(0.1)
    plt.subplots_adjust(bottom=0.2)
    
    labels = []
    for x in xvals:
        labels.append(str(x)+"-"+str(x+intervals-1))
    plt.xticks(xvals,labels,rotation=45)


def analyze(intvals,stepvals):
    
    #plt.subplot(2,1,1)
    plt.scatter(intvals,stepvals)
    plt.ylabel("collatz size")
    plt.xlabel("n for hailstone(n)")

    for dex in range(len(intvals)):
        print("%d\t%d" % (intvals[dex],stepvals[dex]))
        
if __name__ == '__main__':
    intvals = []
    stepvals = []
    for num in range(1000,2000):
        steps = Collatz.hailstone(num, False)
        intvals.append(num)
        stepvals.append(steps)
    analyze(intvals,stepvals)
    #groupplot(intvals,stepvals,10)
    
    plt.tight_layout()
    plt.show()