'''
Created on Feb 19, 2018

@author: ola
'''
import tkinter
import tkinter.filedialog

def getFileData():
    """
    return list of [count,word] pairs (two-element lists)
    where count is # occurrences of word in a file
    the user chooses
    """
    
    # let user choose file, deal with nothing chosen
    global root 
    fname = tkinter.filedialog.askopenfilename(initialdir="./data")
    root.update()
    if len(fname) == 0:
        return []
    
    # invariant: counts[k] == # occurrences of words[k]
    words = []
    counts = []
    f = open(fname, encoding="utf-8")
    for line in f:
        data = line.strip().split()
        
        for word in data:
            word = word.lower()
            if word not in words:
                words.append(word)
                counts.append(0)
            location = words.index(word)
            counts[location] += 1
            
    #return a list of two-element lists
    ret = []
    for dex in range(len(words)):
        ret.append([counts[dex],words[dex]])
    
    return ret
            
def processFile():
    """
    Get data about words/occurrences and print
    some information to console
    """
    data = getFileData()
    if len(data) == 0:
        print("no data read")
        return
    
    mx = max(data)
    sdata = sorted(data)
  
    for one in sdata[-20:]:
        print(one)
    
    print("max is",mx)
    print("total number of different words",len(data))
    tot = 0
    for one in data:
        tot += one[0]
    print("total number of words",tot)
    
if __name__ == '__main__':
    global root
    
    # see StackOverflow and other posts for this
    # remove 'window' from being displayed
    
    root = tkinter.Tk()
    root.withdraw()
    
    processFile()